#ifndef DEFNS_H
#define DEFNS_H

/*
    newsstar - advanced news fetcher
    Copyright (C) 2001-2002 Tony Houghton <h@realh.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* Definitions used throughout */


#ifndef CONFIG_H
#include <config.h>
#ifndef CONFIG_H
#define CONFIG_H
#endif
#endif

#ifndef MAIN_CONF
#define MAIN_CONF CONF_DIR "/main.cf"
#endif

#undef BOOL
#define BOOL int
#undef TRUE
#define TRUE 1
#undef FALSE
#define FALSE 0

#define UNUSED(a) (void) a

/* Stop-gap so we can use i18n in future */
#define _(s) s
#define N_(s) s

/* Put typedef structs together because of mutual dependencies */
typedef struct ServerData ServerData;
typedef struct GroupData GroupData;
typedef struct NSThread NSThread;
typedef struct Article Article;
typedef struct KiddyData KiddyData;
typedef struct ChildData ChildData;
typedef struct Intercom Intercom;
typedef struct intercom_data intercom_data;
typedef struct HashTree HashTree;

#endif /* DEFNS_H */
