/*
    newsstar - advanced news fetcher
    Copyright (C) 2001-2002 Tony Houghton <h@realh.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "common.h"

#include "histcheck.h"
#include "history.h"
#include "local.h"
#include "nntp.h"

static BOOL histcheck_implementation(const char *msgid)
{
    const char *response;

    if (rw_writef(local_buf, "CHECK %s\r\n", msgid) <= 0)
    {
	deblog_error(_("Can't check history: socket error\n"));
    }
    response = rw_read_line(local_buf);
    if (!response || (response[0] != '2' && response[0] != '4'))
    {
	deblog_error(_("Bad response to CHECK: %s\n"),
		response ? response : _("no response from server"));
    }
    return response[0] == '4';
}

void histcheck_init(void)
{
    local_init();
    history_register_implementation(histcheck_implementation, NULL);
}

