/*
    newsstar - advanced news fetcher
    Copyright (C) 2001-2002 Tony Houghton <h@realh.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "history.h"

/* For some reason NULL isn't accepted here, but 0 is */
static history_check_hook history_implementation = 0;
static history_add_hook history_add_implementation = 0;

BOOL history_check(const char *msgid)
{
    return history_implementation ? (*history_implementation)(msgid) : FALSE;
}

void history_add(const char *msgid)
{
    if (history_add_implementation)
	(*history_add_implementation)(msgid);
}

void history_register_implementation(history_check_hook check, history_add_hook
	add)
{
    history_implementation = check;
    history_add_implementation = add;
}

