#ifndef MAINCF_H
#define MAINCF_H

/*
    newsstar - advanced news fetcher
    Copyright (C) 2001-2002 Tony Houghton <h@realh.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* Loads main config file and allows other things to read settings */


#ifndef DEFNS_H
#include "defns.h"
#endif

void maincf_init(void);

long int maincf_get_threads_per_server(void);
long int maincf_get_max_threads(void);
BOOL maincf_get_pipeline(void);
const char *maincf_get_path(void);
const char *maincf_get_history_method(void);
const char *maincf_get_post_method(void);
long int maincf_get_gdbm_expiry(void);
BOOL maincf_get_gdbm_fast(void);
BOOL maincf_get_using_sn(void);
const char *maincf_get_snews_history(void);
BOOL maincf_get_regulate_updates(void);
BOOL maincf_get_regex_ic(void);
BOOL maincf_get_report_dups(void);
BOOL maincf_get_local_ssl(void);

#if ENABLE_ICONV
const char *maincf_get_convert_to_charset(void);
const char *maincf_get_convert_from_charset(void);
const char *maincf_get_ole_charset(void);
const char *maincf_get_transfer_encoding(void);
#endif

/* File/directory pathnames */
const char *maincf_get_spool_dir(void);
const char *maincf_get_outgoing_dir(void);

/* Let maincf know we're using sn rather than INN */
void maincf_use_sn(void);

/* Let maincf know we're using s-news rather than INN */
void maincf_use_snews(void);

/* Allows max_threads to be revised if total of servers' threads is lower */
void maincf_reset_max_threads(long int);
    
#endif /* ! MAINCF_H */
