#ifndef SCORE_H
#define SCORE_H

/*
    newsstar - advanced news fetcher
    Copyright (C) 2001-2002 Tony Houghton <h@realh.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* Score/killfile */


#ifndef DEFNS_H
#include "defns.h"
#endif

typedef struct score_t score_t;

/* Loads score regex file for named server and returns an array of compiled
 * regexes and scores for future matching or NULL if there is no score file. */
score_t *score_load(const char *server_name);

/* score_calculate calculates score from an array of score_t's built earlier.
 * Headers is a contiguous string of all the headers with \n at the end of each
 * line. Result assumes a default_score of 0, so should be added to the
 * server's actual default score. A master.score file is also used - score_load
 * loads it the first time it's called - use score_have_master() to find out
 * whether score_calculate should be called even if server's score file is
 * NULL, in which case use scores argument of NULL. */
#ifdef HAVE_REGEX_H
long int score_calculate(const score_t *scores, const char *headers);
BOOL score_have_master(void);
#else
#define score_calculate(s, h) 0
#define score_have_master() FALSE
#endif /* HAVE_REGEX_H */

#endif /* SCORE_H */
