/*
    newsstar - advanced news fetcher
    Copyright (C) 2001-2002 Tony Houghton <h@realh.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <string.h>

#include "deblog.h"
#include "stdx.h"
#include "vector.h"

#define VEC_INITIAL_SIZE 4 /* Must be > 0 */

typedef struct VECTOR(char) vector_of_char;

void vector_init(size_t *pseudo_vec, size_t item_size)
{
    vector_of_char *vec = (vector_of_char *) pseudo_vec;

    vec->vec_item_size = item_size;
    vec->vec_data = XCALLOC(VEC_INITIAL_SIZE, item_size);
    vec->vec_avail_members = VEC_INITIAL_SIZE;
    vec->vec_used_members = 0;
}

size_t vector_append(size_t *pseudo_vec, const void *pitem)
{
    vector_of_char *vec = (vector_of_char *) pseudo_vec;

    if (vec->vec_used_members + 1 >= vec->vec_avail_members)
    {
	vec->vec_data = XREALLOC(vec->vec_data,
		(vec->vec_avail_members *= 2) * vec->vec_item_size);
    }
    memcpy(vec->vec_data + (vec->vec_used_members * vec->vec_item_size),
	    pitem, vec->vec_item_size);
    return ++(vec->vec_used_members);
}

