#ifndef VECTOR_H
#define VECTOR_H

/*
    newsstar - advanced news fetcher
    Copyright (C) 2001-2002 Tony Houghton <h@realh.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* Rough attempt at C++-style vectors */


#include <assert.h>
#include <stddef.h>

#define VECTOR_MEMBERS(vec_type) \
    size_t vec_item_size; \
    size_t vec_used_members; \
    size_t vec_avail_members; \
    vec_type *vec_data

#define VECTOR(vec_type) { VECTOR_MEMBERS(vec_type); }

#define VECTOR_INIT(vec, vec_type) \
    vector_init(&((vec).vec_item_size), sizeof(vec_type))
#define VECTORP_INIT(pvec, vec_type) \
    vector_init(&((pvec)->vec_item_size), sizeof(vec_type))

/* Append returns new value of vec_used_members */
#define VECTOR_APPEND(vec, item) \
    (assert(sizeof(item) == (vec).vec_item_size), \
    vector_append(&((vec).vec_item_size), &(item)))
#define VECTORP_APPEND(pvec, item) \
    (assert(sizeof(item) == (pvec)->vec_item_size), \
    vector_append(&((pvec)->vec_item_size), &(item)))


/* Don't call these directly, only use the macros */
    
void vector_init(size_t *vec, size_t item_size);

size_t vector_append(size_t *vec, const void *pitem);

#endif /* VECTOR_H */
