/*
    newsstar - advanced news fetcher
    Copyright (C) 2001-2002 Tony Houghton <h@realh.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "deblog.h"
#include "stdx.h"
#include "xpat.h"

XPatExpression *xpat_expression_new(const char *header, const char *regexp)
{
    XPatExpression *expr = XMALLOC(sizeof(XPatExpression));
    
    expr->header = XSTRDUP(header);
    expr->regexp = XSTRDUP(regexp);
    expr->last_downloaded = 0;

    return expr;
}

XPatExpressions *xpat_expressions_new(void)
{
    XPatExpressions *exprs = XMALLOC(sizeof(XPatExpressions));

    VECTORP_INIT(exprs, XPatExpression *);
    exprs->last_run = 0;

    return exprs;
}

XPatArticles *xpat_articles_new(void)
{
    XPatArticles *xparts = XMALLOC(sizeof(XPatArticles));

    VECTORP_INIT(xparts, long int);
    xparts->last_requested = 0;

    return xparts;
}
