#ifndef XPAT_H
#define XPAT_H

/*
    newsstar - advanced news fetcher
    Copyright (C) 2001-2002 Tony Houghton <h@realh.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* Keeps track of articles which are unavailable, in case they become available
 * later */


#ifndef DEFNS_H
#include "defns.h"
#endif

#include "vector.h"

/* "group/server" means "a particular group on a particular server" */

typedef struct
{
    char *header;
    char *regexp;
    long int last_downloaded;
} XPatExpression;

XPatExpression *xpat_expression_new(const char *header, const char *regexp);


/* All xpat expressions to be run on a group/server */
typedef struct
{
    VECTOR_MEMBERS(XPatExpression *);
    size_t last_run;
} XPatExpressions;

XPatExpressions *xpat_expressions_new(void);


/* All articles found by xpat in a group/server */
typedef struct
{
    VECTOR_MEMBERS(long int);	/* Article number on the server */
    size_t last_requested;
} XPatArticles;

XPatArticles *xpat_articles_new(void);

#endif /* XPAT_H */
